package com.koutra.dist.proc.cluster;

import java.util.ArrayList;
import java.util.List;

import org.jgroups.Address;

public class ClusterNodeInfo {
	private Address address;
	private int rank;
	private List<Request> pendingRequests;
	
	public ClusterNodeInfo(Address address, int rank) {
		this.address = address;
		this.rank = rank;
		this.pendingRequests = new ArrayList<Request>();
	}
	
	public Address getAddress() {
		return address;
	}
	
	public int getRank() {
		return rank;
	}
	
	public void setRank(int rank) {
		this.rank = rank;
	}
	
	public void addRequest(Request request) {
		pendingRequests.add(request);
	}
	
	public void removeRequest(Request request) {
		pendingRequests.remove(request);
	}
	
	public List<Request> getPendingRequests() {
		return new ArrayList<Request>(pendingRequests);
	}
}
