/*******************************************************************************
 * Copyright (c) 2009 Pafsanias Ftakas.
 *
 * This file is part of DistProc.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * DistProc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Eclipse Public License v1.0 for more details.
 *
 * Contributors:
 *     Pafsanias Ftakas - initial API and implementation
 *******************************************************************************/
package com.koutra.dist.proc.util;

public class ByteArrayUtil {
	public static String getHexDump(byte[] buffer, int off, int len) {
		StringBuilder sb = new StringBuilder("[");
		for (int i = 0; i < len; i++) {
			if (i == 5) {
				sb.append(",...");
				break;
			}
			if (sb.length() != 1)
				sb.append(",");
			int v = buffer[off + i];
			if (v < 0)
				v = -1 * v;
			sb.append(Integer.toHexString(v));
		}
		sb.append("]");
		if (len > 5)
			sb.append("(" + len + ")");
		
		return sb.toString();
	}
	
	public static String getFullHexDump(byte[] buffer, int off, int len) {
		StringBuilder sb = new StringBuilder("[");
		for (int i = 0; i < len; i++) {
			if (sb.length() != 1)
				sb.append(",");
			int v = buffer[off + i];
			if (v < 0)
				v = -1 * v;
			sb.append(Integer.toHexString(v));
		}
		sb.append("]");
		
		return sb.toString();
	}
	
	public static String encodeInHex(byte[] buffer, int off, int len) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < len; i++) {
			int v = buffer[off + i];
			if (v < 0)
				v = -1 * v;
			if (v < 16)
				sb.append('0');
			sb.append(Integer.toHexString(v));
		}
		
		return sb.toString();
	}
	
	public static byte[] decodeFromHex(String value) {
		char[] valueArray = value.toCharArray();
		if (valueArray.length % 2 != 0)
			throw new IllegalArgumentException("Unable to convert string: " + value +
					" from HEX, since its length is odd.");
		byte[] retVal = new byte[valueArray.length / 2];
		for (int i = 0; i < valueArray.length; i = i + 2) {
			retVal[i / 2] = (byte) Integer.parseInt(new String(valueArray, i, 2), 16);
		}
		return retVal;
	}

}
